Create post
Create a new post. Requires a private API key. Category is required. If authors are not provided, the first workspace author is used.
curl --request POST \
--url https://api.marblecms.com/v1/posts \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data @- <<EOF
{
"title": "Getting Started with Next.js",
"content": "<p>Hello world</p>",
"description": "A beginner's guide to Next.js",
"slug": "getting-started-with-nextjs",
"categoryId": "cryitfjp2345kl05weoybfk9",
"status": "draft",
"tags": [
"cryitfjp4567no07ygqadhm1"
],
"authors": [
"cryitfjp3456lm06xfpzcgl0"
],
"featured": false,
"coverImage": "https://media.marblecms.com/cover.jpg",
"publishedAt": "2024-01-15T10:00:00Z",
"fields": {
"release_date": "2024-01-15",
"priority_score": 5,
"audience": [
"developers",
"founders"
],
"featured_customer": true,
"subtitle": null
}
}
EOFimport requests
url = "https://api.marblecms.com/v1/posts"
payload = {
"title": "Getting Started with Next.js",
"content": "<p>Hello world</p>",
"description": "A beginner's guide to Next.js",
"slug": "getting-started-with-nextjs",
"categoryId": "cryitfjp2345kl05weoybfk9",
"status": "draft",
"tags": ["cryitfjp4567no07ygqadhm1"],
"authors": ["cryitfjp3456lm06xfpzcgl0"],
"featured": False,
"coverImage": "https://media.marblecms.com/cover.jpg",
"publishedAt": "2024-01-15T10:00:00Z",
"fields": {
"release_date": "2024-01-15",
"priority_score": 5,
"audience": ["developers", "founders"],
"featured_customer": True,
"subtitle": None
}
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
title: 'Getting Started with Next.js',
content: '<p>Hello world</p>',
description: 'A beginner\'s guide to Next.js',
slug: 'getting-started-with-nextjs',
categoryId: 'cryitfjp2345kl05weoybfk9',
status: 'draft',
tags: ['cryitfjp4567no07ygqadhm1'],
authors: ['cryitfjp3456lm06xfpzcgl0'],
featured: false,
coverImage: 'https://media.marblecms.com/cover.jpg',
publishedAt: '2024-01-15T10:00:00Z',
fields: {
release_date: '2024-01-15',
priority_score: 5,
audience: ['developers', 'founders'],
featured_customer: true,
subtitle: null
}
})
};
fetch('https://api.marblecms.com/v1/posts', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"post": {
"id": "cryitfjp5678mn09qrstuvwx",
"slug": "getting-started-with-nextjs",
"title": "Getting Started with Next.js",
"status": "draft",
"featured": false,
"publishedAt": "2024-01-15T10:00:00.000Z",
"createdAt": "2024-01-15T10:00:00.000Z"
}
}{
"error": "Invalid query parameters",
"details": [
{
"field": "limit",
"message": "Expected number, received string"
}
],
"message": "Validation failed"
}{
"error": "Forbidden",
"message": "Write operations require a private API key (msk_...). Public keys are read-only."
}{
"error": "Slug already in use",
"message": "A resource with this slug already exists in this workspace"
}{
"error": "Internal server error",
"message": "Failed to fetch resource"
}Authorizations
Your Marble API key
Body
1"Getting Started with Next.js"
1"<p>Hello world</p>"
1"A beginner's guide to Next.js"
1"getting-started-with-nextjs"
1"cryitfjp2345kl05weoybfk9"
published, draft "draft"
Array of tag IDs to attach to the post
["cryitfjp4567no07ygqadhm1"]
Array of author IDs. If omitted, the first workspace author is used.
["cryitfjp3456lm06xfpzcgl0"]
false
"https://media.marblecms.com/cover.jpg"
ISO 8601 datetime. Defaults to current time if omitted.
"2024-01-15T10:00:00Z"
Custom field values keyed by field key. Select values must use option values; multiselect values must be arrays of option values. Use null to clear optional fields.
Show child attributes
Show child attributes
{ "release_date": "2024-01-15", "priority_score": 5, "audience": ["developers", "founders"], "featured_customer": true, "subtitle": null }
Response
Post created successfully
Show child attributes
Show child attributes
Was this page helpful?
